<?php
include '../../DB_connection.php';
$db = mysqli_connect($DB_adress,$DB_name,$DB_pass,$CS_name,$DB_port);
if (!$db)
{
    exit("Verbindungsfehler: ".mysqli_connect_error());
}
mysqli_set_charset($db, 'utf8');

function jsonErr($description) {
	header('Content-Type: application/json');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Expires: 0');

	$send = [
		'status' => 'error',
		'description' => $description,
	];
	die(json_encode($send));
}

$befehl = $_GET['befehl'];
$court = $_GET['court'];
$art = $_GET['art'];

$result = mysqli_query($db, "SELECT Satz FROM Courts WHERE AnzeigeID = '".$court."'");
$row = mysqli_fetch_assoc ($result);
$satz = $row['Satz'];

$verein = $_GET['verein'];

if ($befehl == "nullnull")
{
	nullnull($satz, $art);
	Spielverlauf_eintragen($court, $verein, $art);
}
elseif ($befehl == "plusEins")
{
	plusEins ($court, $art, $satz, $verein);
	satzPruefung ($court, $art, $satz);
	Spielverlauf_eintragen($court, $verein, $art);
}
elseif ($befehl == "minusEins")
{
	minusEins($art, $court);
}
elseif ($befehl == "lastPointChange")
{
	$lastPoint = minusEins($art, $court);

	if ($lastPoint != 'null')
	{
		$result = mysqli_query($db, "SELECT Satz FROM Courts WHERE AnzeigeID = '".$court."'");
		$row = mysqli_fetch_assoc ($result);
		$satz = $row['Satz'];
	
		if ($lastPoint == 'Heim')
		{
			plusEins ($court, $art, $satz, 'Gast');
			satzPruefung ($court, $art, $satz);
			Spielverlauf_eintragen($court, 'Gast', $art);
		}
		else
		{
			plusEins ($court, $art, $satz, 'Heim');
			satzPruefung ($court, $art, $satz);
			Spielverlauf_eintragen($court, 'Heim', $art);
		}
	}
} elseif ($befehl == 'setzen') {
	if ($_SERVER['REQUEST_METHOD'] != 'POST') {
		jsonErr('befehl=setzen requires POST');
	}

	$stmt = mysqli_prepare($db, 'UPDATE Spiele SET
		HeimSatz1=?, HeimSatz2=?, HeimSatz3=?, HeimSatz4=?, HeimSatz5=?, GastSatz1=?, GastSatz2=?, GastSatz3=?, GastSatz4=?, GastSatz5=?
		WHERE Spiel=?');
	if (!$stmt) {
		jsonErr(mysqli_error($db));
	}

	if (!mysqli_stmt_bind_param($stmt, 'iiiiiiiiiis',
			$_POST['HeimSatz1'], $_POST['HeimSatz2'], $_POST['HeimSatz3'], $_POST['HeimSatz4'], $_POST['HeimSatz5'],
			$_POST['GastSatz1'], $_POST['GastSatz2'], $_POST['GastSatz3'], $_POST['GastSatz4'], $_POST['GastSatz5'],
			$art)) {
		jsonErr(mysqli_error($db));
	}
	if (!mysqli_stmt_execute($stmt)) {
		jsonErr(mysqli_error($db));
	}

	$oben = (($_POST['team_links'] == 'heim') xor (intval($court) == 2)) ? 'heim' : 'gast';
	$aufschlag = ballPos($oben, $_POST['team_aufschlag'], intval($_POST['aufschlag_score']));

	// heim_spieler1_links und gast_spieler1_links sind aus der Perspektive der Spieler.
	// Rechne um in Anzeige-Koordinaten
	$linksheim = ((
		($_POST['heim_spieler1_links'] == 'true') xor ($oben == 'heim')
	) ? 'Spieler1' : 'Spieler2');
	$linksgast = ((
		($_POST['gast_spieler1_links'] == 'true') xor ($oben == 'gast')
	) ? 'Spieler1' : 'Spieler2');

	$stmt = mysqli_prepare($db, 'UPDATE Courts SET
		Anzeige=?, Detail=?,
		Satz=?, gewonnenHeim=?, gewonnenGast=?,
		oben=?, linksheim=?, linksgast=?,
		Aufgabe=?
		WHERE AnzeigeID=?
	');
	if (!$stmt) {
		jsonErr(mysqli_error($db));
	}

	$satz_int = intval($_POST['Satz']);
	$gewonnenHeim = intval($_POST['gewonnenHeim']);
	$gewonnenGast = intval($_POST['gewonnenGast']);
	$court_int = intval($court);

	if (!mysqli_stmt_bind_param($stmt, 'ssiiisssii',
			$art, $_POST['Detail'],
			$satz_int, $gewonnenHeim, $gewonnenGast,
			$oben, $linksheim, $linksgast,
			$aufschlag,
			$court_int)) {
		jsonErr(mysqli_error($db));
	}
	if (!mysqli_stmt_execute($stmt)) {
		jsonErr(mysqli_error($db));
	}
	if (!mysqli_stmt_close($stmt)) {
		jsonErr('Failed to close handle: ' . mysqli_error($db));
	}

	// Lösche etwaiige Undos im Spielverlauf
	$stmt = mysqli_prepare($db, '
		DELETE delete_table.* FROM Spielverlauf AS delete_table
		JOIN (
			SELECT MIN(Spielstep) as min_step FROM Spielverlauf
			WHERE Art=?
				AND HeimSatz1=? AND HeimSatz2=? AND HeimSatz3=? AND HeimSatz4=? AND HeimSatz5=?
				AND GastSatz1=? AND GastSatz2=? AND GastSatz3=? AND GastSatz4=? AND GastSatz5=?
		) select_vals
		ON (
			delete_table.Art = ?
			AND delete_table.Spielstep >= select_vals.min_step
			AND delete_table.Spielstep > 0
		)
	');
	if (!$stmt) {
		jsonErr('Datenbank-Fehler: ' . mysqli_error($db));
	}
	if (!mysqli_stmt_bind_param($stmt, 'siiiiiiiiiis',
			$art,
			$_POST['HeimSatz1'], $_POST['HeimSatz2'], $_POST['HeimSatz3'], $_POST['HeimSatz4'], $_POST['HeimSatz5'],
			$_POST['GastSatz1'], $_POST['GastSatz2'], $_POST['GastSatz3'], $_POST['GastSatz4'], $_POST['GastSatz5'],
			$art
			)) {
		jsonErr(mysqli_error($db));
	}
	if (!mysqli_stmt_execute($stmt)) {
		jsonErr(mysqli_error($db));
	}
	if (!mysqli_stmt_close($stmt)) {
		jsonErr('Failed to close handle: ' . mysqli_error($db));
	}

	Spielverlauf_eintragen($court, $verein, $art, $_POST['presses_json']);

	header('Content-Type: application/json');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Expires: 0');
	echo json_encode([
		'status' => 'ok',
	]);
}


mysqli_query($db, "UPDATE Verwaltung SET lfdnum=lfdnum+1 WHERE ID = '1'");

function Spielverlauf_eintragen($court, $verein, $art, $presses_json=NULL, $update=true)
{
	global $db;

	$result = mysqli_query($db, 'SELECT * FROM Courts WHERE AnzeigeID = '.$court);
	$rowa = mysqli_fetch_assoc ($result);

	$result = mysqli_query($db, "SELECT MAX(Spielstep) FROM Spielverlauf WHERE Art = '".$art."'");
	$rowb = mysqli_fetch_assoc ($result);
	$maximum = $rowb['MAX(Spielstep)'];
	
	$maximum++;

	$result = mysqli_query($db, "SELECT * FROM Spiele WHERE Spiel = '".$art."'");
	$rowb = mysqli_fetch_assoc ($result);

$sql = <<<SQL
INSERT INTO `Spielverlauf`
		(`Art`,
		 `Spielstep`,
		 `Detail`,
		 `Satz`,
		 `gewonnenHeim`,
		 `gewonnenGast`,
		 `oben`,
		 `linksheim`,
		 `linksgast`,
		 `Aufgabe`,
		 `HeimSatz1`,
		 `GastSatz1`,
		 `HeimSatz2`,
		 `GastSatz2`,
		 `HeimSatz3`,
		 `GastSatz3`,
		 `HeimSatz4`,
		 `GastSatz4`,
		 `HeimSatz5`,
		 `GastSatz5`,
		 `lastPoint`,
		 `presses_json`,
		 `ts`
		) VALUES
		(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, CURRENT_TIMESTAMP)
SQL;

	$stmt = mysqli_prepare($db, $sql);
	if (!$stmt) {
		if ((mysqli_errno($db) == 1054) && $update) {
			$alter = mysqli_prepare($db, 'ALTER TABLE Spielverlauf ADD COLUMN presses_json LONGTEXT;');
			if (!$alter) {
				jsonErr('update preparation failed: ' . mysqli_error($db));
			}
			if (!mysqli_stmt_execute($alter)) {
				jsonErr('update exec failed: ' . mysqli_error($db));	
			}
			return Spielverlauf_eintragen($court, $verein, $art, $presses_json, false);
		}

		jsonErr(mysqli_error($db));
	}
	if (!@mysqli_stmt_bind_param($stmt, 'sisssssssiiiiiiiiiiiss',
			$art,
		 	$maximum,
			$rowa['Detail'],
			$rowa['Satz'],
			$rowa['gewonnenHeim'],
			$rowa['gewonnenGast'],
			$rowa['oben'],
			$rowa['linksheim'],
			$rowa['linksgast'],
			$rowa['Aufgabe'],
			$rowb['HeimSatz1'],
			$rowb['GastSatz1'],
			$rowb['HeimSatz2'],
			$rowb['GastSatz2'],
			$rowb['HeimSatz3'],
			$rowb['GastSatz3'],
			$rowb['HeimSatz4'],
			$rowb['GastSatz4'],
			$rowb['HeimSatz5'],
			$rowb['GastSatz5'],
			$verein,
			$presses_json
			)) {
		jsonErr(mysqli_error($db));
	}
	if (!mysqli_stmt_execute($stmt)) {
		jsonErr(mysqli_error($db));
	}
}

function plusEins ($court, $art, $satz, $verein)
{
	global $db;

	$result = mysqli_query($db, "SELECT ".$verein."Satz".$satz." FROM Spiele WHERE Spiel = '".$art."'");
	$row = mysqli_fetch_assoc ($result);
	$punkte = intval($row[$verein."Satz".$satz]) + 1;
	mysqli_query($db, "UPDATE Spiele SET ".$verein."Satz".$satz." = '".$punkte."' WHERE Spiel = '".$art."'");

	$fuenfterSatzDrehung = FALSE;
	// Sonderfall: das erste Mal 11 Punkte im 3. Satz
	if (($satz == '5') && (intval($punkte) == 6))
	{
		// den anderen Stand holen, um zu schauen, ob es die "erste" 6 ist
		if ($verein == 'Heim')
		{
			$result = mysqli_query($db, "SELECT GastSatz".$satz." FROM Spiele WHERE Spiel = '".$art."'");
			$row = mysqli_fetch_assoc ($result);
			$gegner = intval($row["GastSatz".$satz]);
		}
		else
		{
			$result = mysqli_query($db, "SELECT HeimSatz".$satz." FROM Spiele WHERE Spiel = '".$art."'");
			$row = mysqli_fetch_assoc ($result);
			$gegner = intval($row["HeimSatz".$satz]);
		}
		if ($gegner < 6)
			$fuenfterSatzDrehung = TRUE;
	}

	// alte Positionen laden
	$result = mysqli_query($db, 'SELECT * FROM Courts WHERE AnzeigeID = '.$court);
	$row = mysqli_fetch_assoc ($result);

	$oben = $row['oben'];

	if ($fuenfterSatzDrehung)
	{
		if ($oben == 'heim')
		{
			$oben = 'gast';
		}
		else
		{
			$oben = 'heim';
		}
		mysqli_query($db, "UPDATE Courts SET oben = '".$oben."' WHERE AnzeigeID = '".$court."'");
	}
	
	// Ball positionieren
	mysqli_query($db, "UPDATE Courts SET Aufgabe = '".ballPos($oben, $verein, $punkte)."' WHERE AnzeigeID = '".$court."'");

	if (($art == "DE") || ($art == "1.HE") || ($art == "2.HE"))
	{
		//EINZEL
		if ($verein == 'Heim')
		{
			$heimsp = ($oben == 'heim')? 0 : 1;
			$heimsp = (gerade($punkte))? $heimsp : 1-$heimsp;
			$gastsp = 1-$heimsp;
		}
		else
		{
			$gastsp = ($oben == 'gast')? 0 : 1;
			$gastsp = (gerade($punkte))? $gastsp : 1-$gastsp;
			$heimsp = 1-$gastsp;
		}
		$heimsp = ($heimsp == 0)? 'Spieler1' : 'Spieler2';
		$gastsp = ($gastsp == 0)? 'Spieler1' : 'Spieler2';

		mysqli_query($db, "UPDATE Courts SET linksheim = '".$heimsp."' WHERE AnzeigeID = '".$court."'");
		mysqli_query($db, "UPDATE Courts SET linksgast = '".$gastsp."' WHERE AnzeigeID = '".$court."'");
	}
	else
	{
		//DOPPEL
		// wer hatte zuletzt Aufgabe? Entscheiden, ob Aufgabenwechsel oder drehen
		$aufgabe = $row['Aufgabe'];
		if ($row['oben'] == 'heim')
		{
			if ((intval($aufgabe) < 3) && ($verein == "Heim"))
			{
				if ($fuenfterSatzDrehung)
				{
					drehen('gast');
				}
				else
				{
					// Heim hat bei eigenem Aufschlag Punkt gemacht, drehen
					drehen('heim');
				}
			}
			elseif ((intval($aufgabe) > 2) && ($verein == "Gast"))
			{
				if ($fuenfterSatzDrehung)
				{
					drehen('heim');
				}
				else
				{
					// Gast hat bei eigenem Aufschlag Punkt gemacht, drehen
					drehen('gast');
				}
			}
			elseif ($fuenfterSatzDrehung)
			{
				drehen('heim');
				drehen('gast');
			}
		}
		else
		{
			if ((intval($aufgabe) < 3) && ($verein == "Gast"))
			{
				if ($fuenfterSatzDrehung)
				{
					drehen('heim');
				}
				else
				{
					// Gast hat bei eigenem Aufschlag Punkt gemacht, drehen
					drehen('gast');
				}
			}
			elseif ((intval($aufgabe) > 2) && ($verein == "Heim"))
			{
				if ($fuenfterSatzDrehung)
				{
					drehen('gast');
				}
				else
				{
					// Heim hat bei eigenem Aufschlag Punkt gemacht, drehen
					drehen('heim');
				}
			}
			elseif ($fuenfterSatzDrehung)
			{
				drehen('heim');
				drehen('gast');
			}
		}
	}
}

function minusEins($art, $court)
{
	global $db;

	$result = mysqli_query($db, "SELECT MAX(Spielstep) FROM Spielverlauf WHERE Art = '".$art."'");
	$rowb = mysqli_fetch_assoc ($result);
	$maximum = $rowb['MAX(Spielstep)'];

	$result = mysqli_query($db, "SELECT lastPoint FROM Spielverlauf WHERE Art = '".$art."' AND Spielstep = '".$maximum."'");
	$row = mysqli_fetch_assoc ($result);
	$lastPoint = $row['lastPoint'];

	if ($lastPoint != 'null')
	{
		mysqli_query($db, "DELETE FROM Spielverlauf WHERE Art = '".$art."' AND Spielstep = '".$maximum."'");
		
		$result = mysqli_query($db, "SELECT * FROM Spielverlauf WHERE Art = '".$art."' AND Spielstep = (SELECT MAX(Spielstep) FROM Spielverlauf WHERE Art = '".$art."')");
		$row = mysqli_fetch_assoc ($result);
	
$sql = <<<SQL
UPDATE Spiele
	SET HeimSatz1 = '{$row['HeimSatz1']}',
		HeimSatz2 = '{$row['HeimSatz2']}',
		HeimSatz3 = '{$row['HeimSatz3']}',
		HeimSatz4 = '{$row['HeimSatz4']}',
		HeimSatz5 = '{$row['HeimSatz5']}',
		GastSatz1 = '{$row['GastSatz1']}',
		GastSatz2 = '{$row['GastSatz2']}',
		GastSatz3 = '{$row['GastSatz3']}',
		GastSatz4 = '{$row['GastSatz4']}',
		GastSatz5 = '{$row['GastSatz5']}'
	WHERE Spiel = '{$art}'
SQL;
	mysqli_query($db, $sql);

$sql = <<<SQL
UPDATE Courts
	SET Anzeige = '{$row['Art']}',
		Detail = '{$row['Detail']}',
		Satz = '{$row['Satz']}',
		gewonnenHeim = '{$row['gewonnenHeim']}',
		gewonnenGast = '{$row['gewonnenGast']}',
		oben = '{$row['oben']}',
		linksheim = '{$row['linksheim']}',
		linksgast = '{$row['linksgast']}',
		Aufgabe = '{$row['Aufgabe']}'
	WHERE AnzeigeID = '{$court}';
SQL;
		mysqli_query($db, $sql);
	}
	
	return $lastPoint;
}

function drehen($ver)
{
	global $db;
	$court = $_GET['court'];
	$result = mysqli_query($db, "SELECT links".$ver." FROM Courts WHERE AnzeigeID = '".$court."'");
	$row = mysqli_fetch_assoc ($result);
	$erg = $row['links'.$ver];

	if ($erg == 'Spieler1')
	{
		mysqli_query($db, "UPDATE Courts SET links".$ver." = 'Spieler2' WHERE AnzeigeID = '".$court."'");
	}
	else
	{
		mysqli_query($db, "UPDATE Courts SET links".$ver." = 'Spieler1' WHERE AnzeigeID = '".$court."'");
	}
}

function ballPos ($ob, $ver, $erg)
{
	$gerade = gerade($erg);

	if ($ob == 'heim')
	{
		if ($ver == 'Heim')
		{
			if ($gerade)
			{
				return 1;
			}
			else
			{
				return 2;
			}
		}
		else
		{
			if ($gerade)
			{
				return 4;
			}
			else
			{
				return 3;
			}
		}		
	}
	else
	{
		if ($ver == 'Heim')
		{
			if ($gerade)
			{
				return 4;
			}
			else
			{
				return 3;
			}
		}
		else
		{
			if ($gerade)
			{
				return 1;
			}
			else
			{
				return 2;
			}
		}
	}
}

function gerade ($zahl)
{
	if($zahl % 2 == 0)
	   return TRUE;
	else
	   return FALSE;
}

function nullnull($satz, $art)
{
	global $db;
	mysqli_query($db, "UPDATE Spiele SET HeimSatz".$satz." = '0' WHERE Spiel = '".$art."'");
	mysqli_query($db, "UPDATE Spiele SET GastSatz".$satz." = '0' WHERE Spiel = '".$art."'");
}

function satzPruefung ($court, $art, $satz)
{
	global $db;
	// Neuer Satz bzw. Spielende?
	$result = mysqli_query($db, "SELECT * FROM Spiele WHERE Spiel = '".$art."'");
	$row = mysqli_fetch_assoc ($result);
	$punkteHeim = intval($row["HeimSatz".$satz]);
	$punkteGast = intval($row["GastSatz".$satz]);

	$gewonnen = 0;
	$satz_weiter = FALSE;
	if ((($punkteHeim > 10) && ($punkteHeim > ($punkteGast+1))) || ($punkteHeim == 15))
	{
		// Heim hat Satz gewonnen. Nächster Satz.
		$satz_weiter = TRUE;
		$result = mysqli_query($db, "SELECT * FROM Courts WHERE AnzeigeID = '".$court."'");
		$row = mysqli_fetch_assoc ($result);
		$gewonnen = $row['gewonnenHeim'] + 1;		
		mysqli_query($db, "UPDATE Courts SET gewonnenHeim = '".$gewonnen."' WHERE AnzeigeID = '".$court."'");
	}
	else if ((($punkteGast > 10) && ($punkteGast > ($punkteHeim+1))) || ($punkteGast == 15))
	{
		// Gast hat Satz gewonnen. Nächster Satz.
		$satz_weiter = TRUE;
		mysqli_query($db, "UPDATE Courts SET Satz = '".$satz."' WHERE AnzeigeID = '".$court."'");
		$result = mysqli_query($db, "SELECT * FROM Courts WHERE AnzeigeID = '".$court."'");
		$row = mysqli_fetch_assoc ($result);
		$gewonnen = $row['gewonnenGast'] + 1;		
		mysqli_query($db, "UPDATE Courts SET gewonnenGast = '".$gewonnen."' WHERE AnzeigeID = '".$court."'");
	}

	if ($satz_weiter && ($satz < 5) && ($gewonnen < 3))
	{
		$satz++;
		mysqli_query($db, "UPDATE Courts SET Satz = '".$satz."' WHERE AnzeigeID = '".$court."'");
		nullnull($satz, $art);
		mysqli_query($db, "UPDATE Courts SET Detail = 'Punkte' WHERE AnzeigeID = '".$court."'");
		
		// Seitenwechsel
		$Aufgabe = $row['Aufgabe'];
		$oben = $row['oben'];
	
		// wer behält die Aufgabe?
		if ($oben == "heim")
		{
			if ($Aufgabe < 3)
			{
				$aufgabe_behaelt = 'Heim';
			}
			else
			{
				$aufgabe_behaelt = 'Gast';
			}		
		}
		else
		{
			if ($Aufgabe < 3)
			{
				$aufgabe_behaelt = 'Gast';
			}
			else
			{
				$aufgabe_behaelt = 'Heim';
			}		
		}
			
		if ($oben == "heim")
		{
			$ergebnis = 'gast';
		}
		else
		{
			$ergebnis = 'heim';
		}
		// Ball positionieren
		mysqli_query($db, "UPDATE Courts SET Aufgabe = '".ballPos($ergebnis, $aufgabe_behaelt, 0)."' WHERE AnzeigeID = '".$court."'");
	
		mysqli_query($db, "UPDATE Courts SET oben = '".$ergebnis."' WHERE AnzeigeID = '".$court."'");
	
		if (($art == "DE") || ($art == "1.HE") || ($art == "2.HE"))
		{
			//EINZEL
			if ($aufgabe_behaelt == 'Heim')
			{
				$heimsp = ($ergebnis == 'heim')? 0 : 1;
				$gastsp = 1-$heimsp;
			}
			else
			{
				$gastsp = ($ergebnis == 'gast')? 0 : 1;
				$heimsp = 1-$gastsp;
			}
			$heimsp = ($heimsp == 0)? 'Spieler1' : 'Spieler2';
			$gastsp = ($gastsp == 0)? 'Spieler1' : 'Spieler2';
	
			mysqli_query($db, "UPDATE Courts SET linksheim = '".$heimsp."' WHERE AnzeigeID = '".$court."'");
			mysqli_query($db, "UPDATE Courts SET linksgast = '".$gastsp."' WHERE AnzeigeID = '".$court."'");
		}
		
	}
	if ($gewonnen == 3)
	{
		mysqli_query($db, "UPDATE Courts SET Detail = 'Punkte' WHERE AnzeigeID = '".$court."'");
	}
}
?>