<?php
include '../../DB_connection.php';
include '../version.php';

$db = mysqli_connect($DB_adress,$DB_name,$DB_pass,'mysql',$DB_port);
if (!$db)
{
    exit("Verbindungsfehler: ".mysqli_connect_error());
}
mysqli_set_charset($db, 'utf8');

$sql = <<<SQL
DROP DATABASE IF EXISTS `{$CS_name}`;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Löschen fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
CREATE DATABASE `{$CS_name}` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("DB anlegen fehlgeschlagen: ".mysqli_error($db));
    }

mysqli_select_db($db, $CS_name);

$sql = <<<SQL
CREATE TABLE `Courts` (
  `AnzeigeID` int(11) NOT NULL,
  `Anzeige` char(4) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Detail` char(6) NOT NULL,
  `Satz` int(1) NOT NULL,
  `gewonnenHeim` int(1) NOT NULL,
  `gewonnenGast` int(1) NOT NULL,
  `oben` char(4) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `linksheim` char(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `linksgast` char(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Aufgabe` int(1) NOT NULL,
  PRIMARY KEY (`AnzeigeID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Tabelle Courts anlegen fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
INSERT INTO `Courts` (`AnzeigeID`, `Anzeige`, `Detail`, `Satz`, `gewonnenHeim`, `gewonnenGast`, `oben`, `linksheim`, `linksgast`, `Aufgabe`) VALUES
(1, '1.HD', 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1),
(2, 'DD', 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1);
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Initialisieren von Courts fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
CREATE TABLE `Spiele` (
  `Spiel` char(4) NOT NULL,
  `Reihenfolge` int(1) NOT NULL,
  `Heimspieler1VN` text NOT NULL,
  `Heimspieler1NN` text NOT NULL,
  `Heimspieler2VN` text NOT NULL,
  `Heimspieler2NN` text NOT NULL,
  `Gastspieler1VN` text NOT NULL,
  `Gastspieler1NN` text NOT NULL,
  `Gastspieler2VN` text NOT NULL,
  `Gastspieler2NN` text NOT NULL,
  `HeimSatz1` int(2) NOT NULL,
  `GastSatz1` int(2) NOT NULL,
  `HeimSatz2` int(2) NOT NULL,
  `GastSatz2` int(2) NOT NULL,
  `HeimSatz3` int(2) NOT NULL,
  `GastSatz3` int(2) NOT NULL,
  `HeimSatz4` int(2) NOT NULL,
  `GastSatz4` int(2) NOT NULL,
  `HeimSatz5` int(2) NOT NULL,
  `GastSatz5` int(2) NOT NULL,
  PRIMARY KEY (`Spiel`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Tabelle Spiele anlegen fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
INSERT INTO `Spiele` (`Spiel`, `Reihenfolge`, `Heimspieler1VN`, `Heimspieler1NN`, `Heimspieler2VN`, `Heimspieler2NN`, `Gastspieler1VN`, `Gastspieler1NN`, `Gastspieler2VN`, `Gastspieler2NN`, `HeimSatz1`, `GastSatz1`, `HeimSatz2`, `GastSatz2`, `HeimSatz3`, `GastSatz3`, `HeimSatz4`, `GastSatz4`, `HeimSatz5`, `GastSatz5`) VALUES
('1.HD', 1, '', '', '', '', '', '', '', '', -1, -1, -1, -1, -1, -1, -1, -1, -1, -1),
('DD', 2, '', '', '', '', '', '', '', '', -1, -1, -1, -1, -1, -1, -1, -1, -1, -1),
('2.HD', 3, '', '', '', '', '', '', '', '', -1, -1, -1, -1, -1, -1, -1, -1, -1, -1),
('1.HE', 4, '', '', '', '', '', '', '', '', -1, -1, -1, -1, -1, -1, -1, -1, -1, -1),
('DE', 5, '', '', '', '', '', '', '', '', -1, -1, -1, -1, -1, -1, -1, -1, -1, -1),
('GD', 6, '', '', '', '', '', '', '', '', -1, -1, -1, -1, -1, -1, -1, -1, -1, -1),
('2.HE', 7, '', '', '', '', '', '', '', '', -1, -1, -1, -1, -1, -1, -1, -1, -1, -1);
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Initialisieren von Spiele fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
CREATE TABLE `Spielverlauf` (
  `Art` char(4) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Spielstep` int(4) NOT NULL,
  `Detail` char(6) NOT NULL,
  `Satz` int(11) NOT NULL,
  `gewonnenHeim` int(1) NOT NULL,
  `gewonnenGast` int(1) NOT NULL,
  `oben` char(4) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `linksheim` char(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `linksgast` char(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `Aufgabe` int(1) NOT NULL,
  `HeimSatz1` int(2) NOT NULL,
  `GastSatz1` int(2) NOT NULL,
  `HeimSatz2` int(2) NOT NULL,
  `GastSatz2` int(2) NOT NULL,
  `HeimSatz3` int(2) NOT NULL,
  `GastSatz3` int(2) NOT NULL,
  `HeimSatz4` int(2) NOT NULL,
  `GastSatz4` int(2) NOT NULL,
  `HeimSatz5` int(2) NOT NULL,
  `GastSatz5` int(2) NOT NULL,
  `lastPoint` char(4) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `presses_json` LONGTEXT,
  `ts` TIMESTAMP NULL,
  PRIMARY KEY (`Art`,`Spielstep`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Tabelle Spielverlauf anlegen fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
INSERT INTO `Spielverlauf` (`Art`, `Spielstep`, `Detail`, `Satz`, `gewonnenHeim`, `gewonnenGast`, `oben`, `linksheim`, `linksgast`, `Aufgabe`, `HeimSatz1`, `GastSatz1`, `HeimSatz2`, `GastSatz2`, `HeimSatz3`, `GastSatz3`, `HeimSatz4`, `GastSatz4`, `HeimSatz5`, `GastSatz5`, `lastPoint`) VALUES
('1.HD', 0, 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 'null'),
('1.HE', 0, 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 'null'),
('2.HD', 0, 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 'null'),
('2.HE', 0, 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 'null'),
('3.HE', 0, 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 'null'),
('DD', 0, 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 'null'),
('DE', 0, 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 'null'),
('GD', 0, 'leer', 1, 0, 0, 'heim', 'Spieler1', 'Spieler2', 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 'null');
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Initialisieren von Spielverlauf fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
CREATE TABLE `Verwaltung` (
  `ID` int(11) NOT NULL,
  `Heim` text NOT NULL,
  `HeimCourt` text NOT NULL,
  `Gast` text NOT NULL,
  `GastCourt` text NOT NULL,
  `HeimNummer` int(5) NOT NULL,
  `GastNummer` int(5) NOT NULL,
  `SR` text NOT NULL,
  `Liga` int(2) NOT NULL,
  `Bundesliga` int(1) NOT NULL,
  `lfdnum` bigint(20) NOT NULL DEFAULT '0',
  `Ort` text NOT NULL,
  `Spieltag` int(2) NOT NULL,
  `Startzeit` text NOT NULL,
  `Datum` text NOT NULL,
  `Schiedsrichter` text NOT NULL,
  `Protest` text NOT NULL,
  `Notizen` text NOT NULL,
  `URL` text NOT NULL,
  `pass` text,
  `Zuschauer` text NOT NULL,
  `Version` text NOT NULL,
  `AnzeigenReload` int(1) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Tabelle Verwaltung anlegen fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
INSERT INTO `Verwaltung` (`ID`, `Heim`, `HeimCourt`, `Gast`, `GastCourt`, `HeimNummer`, `GastNummer`, `SR`, `Liga`, `Bundesliga`, `lfdnum`, `Ort`, `Spieltag`, `Startzeit`, `Datum`, `Schiedsrichter`, `Protest`, `Notizen`, `URL`, `Zuschauer`, `Version`, `AnzeigenReload`) VALUES
(1, ' ', ' ', ' ', ' ', 0, 0, 'aussen', 0, 1, 1, '', 0, '', '', '', '', '', '', '', '$version', 0);
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Initialisieren von Verwaltung fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
CREATE TABLE `Spieler` (
  `Art` char(8) NOT NULL,
  `Nachname` char(30) NOT NULL,
  `Vorname` char(30) NOT NULL,
  `Rangliste` text NOT NULL,
  `Status` text NOT NULL,
  PRIMARY KEY (`Art`,`Nachname`,`Vorname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Tabelle Spieler anlegen fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
INSERT INTO `Spieler` (`Art`, `Nachname`, `Vorname`, `Rangliste`, `Status`) VALUES
('HeimHerr', 'laden!', 'Spieler', '', ''),
('HeimDame', 'laden!', 'Spieler', '', ''),
('GastHerr', 'laden!', 'Spieler', '', ''),
('GastDame', 'laden!', 'Spieler', '', '');
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Initialisieren von Spieler fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
CREATE TABLE `Schriften` (
  `Schrift` char(3) NOT NULL,
  `Punkt` int(9) NOT NULL,
  `Art` text NOT NULL,
  PRIMARY KEY (`Schrift`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Tabelle Schriften anlegen fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
INSERT INTO `Schriften` (`Schrift`, `Punkt`, `Art`) VALUES
('S0', 1, 'no'),
('S1', '$s1Punkt', '$s1Art'),
('S2', '$s2Punkt', '$s2Art'),
('S3', '$s3Punkt', '$s3Art'),
('S4', '$s4Punkt', '$s4Art'),
('S5', '$s5Punkt', '$s5Art'),
('S6', '$s6Punkt', '$s6Art'),
('S7', '$s7Punkt', '$s7Art'),
('S8', '$s8Punkt', '$s8Art'),
('S9', '$s9Punkt', '$s9Art'),
('S10', '$s10Punkt', '$s10Art'),
('S11', '$s11Punkt', '$s11Art'),
('S12', '$s12Punkt', '$s12Art'),
('S13', '$s13Punkt', '$s13Art');
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Initialisieren von Schriften fehlgeschlagen: ".mysqli_error($db));
    }

$sql = <<<SQL
CREATE TABLE `Unterschriften` (
  `id` varchar(20),
  `image` longtext,
  `ts` bigint,
  `state_json` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
SQL;
	if (!mysqli_query($db, $sql))
    {
        exit("Tabelle Schriften anlegen fehlgeschlagen: ".mysqli_error($db));
    }

echo("Datenbank zur&uuml;ckgesetzt.<br/><br/>");
?>

<html>
<head>
<script>
function replaceDoc()
{
	window.location.replace("../html/Menue.php");
}
</script>
</head>
<body>

<input type="button" value="Zur&uuml;ck zum Men&uuml;" onclick="replaceDoc()">

</body>
</html>
